{ DemoDbgT: Main form
  Copyright (c) 1997 by Skylark Software
  All rights reserved. }

unit DemoUnit;

interface

uses
  {$IFDEF WIN32} Windows, ComCtrls,
  {$ELSE} WinTypes, WinProcs,
  {$ENDIF}
  SysUtils, Messages, DbgTrace, Forms, Graphics, Dialogs, Menus, StdCtrls, Tabs, Spin,
  Controls, ExtCtrls, Classes, TabNotBk;

type
  TfrmDemo = class(TForm)
    MainMenu1: TMainMenu;
    mnFile: TMenuItem;
    mnFExit: TMenuItem;
    mnHelp: TMenuItem;
    mnHDemo: TMenuItem;
    mnHComp: TMenuItem;
    N1: TMenuItem;
    mnHAbout: TMenuItem;
    tnoteDemo: TTabbedNotebook;
    fontDialog: TFontDialog;
    noteAppearance: TNotebook;
    GroupBox2: TGroupBox;
    Label9: TLabel;
    cbWinVisible: TCheckBox;
    cbToolVisible: TCheckBox;
    editFontInfo: TEdit;
    btnWinFont: TButton;
    GroupBox5: TGroupBox;
    cbDateStamp: TCheckBox;
    cbTimeStamp: TCheckBox;
    GroupBox4: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    editSeperator: TEdit;
    spinnerRepeat: TSpinEdit;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label8: TLabel;
    editHeader: TEdit;
    editHeaderFont: TEdit;
    Button1: TButton;
    editSubHeaderFont: TEdit;
    Button2: TButton;
    cbSubHeaderVisible: TCheckBox;
    tsetAppearance: TTabSet;
    GroupBox6: TGroupBox;
    cbLocHorz: TComboBox;
    cbLocVert: TComboBox;
    editTop: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    editLeft: TEdit;
    GroupBox7: TGroupBox;
    cbSizeHeight: TComboBox;
    Label14: TLabel;
    editSizeHeight: TEdit;
    Label15: TLabel;
    cbSizeWidth: TComboBox;
    editSizeWidth: TEdit;
    cbStayOnTop: TCheckBox;
    cboxDebugList: TComboBox;
    btnDoObject: TButton;
    btnDisplay: TButton;
    btnDisplayFmt: TButton;
    btnStrings: TButton;
    btnSeperator: TButton;
    btnVars: TButton;
    btnClear: TButton;
    btnSave: TButton;
    btnPrint: TButton;
    editDisplay: TEdit;
    Memo1: TMemo;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    cbLogging: TCheckBox;
    editLogName: TEdit;
    cbOpenAction: TComboBox;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Hints1: TMenuItem;
    N2: TMenuItem;
    procedure tsetAppearanceChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure cboxDebugListChange(Sender: TObject);
    procedure mnFExitClick(Sender: TObject);
    procedure btnDoObjectClick(Sender: TObject);
    procedure cboxDebugListKeyPress(Sender: TObject; var Key: Char);
    procedure cbWinVisibleClick(Sender: TObject);
    procedure cbToolVisibleClick(Sender: TObject);
    procedure cbStayOnTopClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnDisplayClick(Sender: TObject);
    procedure btnDisplayFmtClick(Sender: TObject);
    procedure btnSeperatorClick(Sender: TObject);
    procedure btnStringsClick(Sender: TObject);
    procedure btnVarsClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnWinFontClick(Sender: TObject);
    procedure editHeaderChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure cbLocHorzChange(Sender: TObject);
    procedure cbLocVertChange(Sender: TObject);
    procedure editTopKeyPress(Sender: TObject; var Key: Char);
    procedure editTopChange(Sender: TObject);
    procedure editLeftChange(Sender: TObject);
    procedure cbSizeHeightChange(Sender: TObject);
    procedure cbSizeWidthChange(Sender: TObject);
    procedure editSizeHeightChange(Sender: TObject);
    procedure editSizeWidthChange(Sender: TObject);
    procedure cbLoggingClick(Sender: TObject);
    procedure cbOpenActionChange(Sender: TObject);
    procedure editLogNameChange(Sender: TObject);
    procedure editSeperatorChange(Sender: TObject);
    procedure spinnerRepeatChange(Sender: TObject);
    procedure cbDateStampClick(Sender: TObject);
    procedure cbTimeStampClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Hints1Click(Sender: TObject);
    procedure mnHAboutClick(Sender: TObject);
  private
    { Private declarations }
    curDebug: TSSDebugTracer;
    updatingDemo: Boolean;

    procedure UpdateDemo;
    function FontDesc(infoFont: TFont): String;

    procedure WMGetMinMaxInfo(var Message: TMessage); message WM_GETMINMAXINFO;

  public
    { Public declarations }
  end;

var
  frmDemo: TfrmDemo;

implementation

uses About;

{$R *.DFM}

procedure TfrmDemo.tsetAppearanceChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  noteAppearance.PageIndex := NewTab;
end;

procedure TfrmDemo.cboxDebugListChange(Sender: TObject);
begin
  if cboxDebugList.ItemIndex <> -1 then btnDoObject.Click;
end;

procedure TfrmDemo.UpdateDemo;
begin
  updatingDemo := True;
  with curDebug do
    begin
      cbWinVisible.Checked := DebugVisible;
      cbToolVisible.Checked := ToolBarVisible;
      cbStayOnTop.Checked := StayOnTop;
      editFontInfo.Text := FontDesc(TextFont);
      editHeader.Text := HeaderText;
      editHeaderFont.Text := FontDesc(HeaderFont);
      cbSubHeaderVisible.Checked := SubHeaderOn;
      editSubHeaderFont.Text := FontDesc(SubHeaderFont);
      cbLocHorz.ItemIndex := Integer(FormLocationH);
      cbLocVert.ItemIndex := Integer(FormLocationV);
      editTop.Text := IntToStr(FormLocationTop);
      editLeft.Text := IntToStr(FormLocationLeft);
      cbSizeHeight.ItemIndex := Integer(FormSizeH);
      cbSizeWidth.ItemIndex := Integer(FormSizeW);
      editSizeHeight.Text := IntToStr(FormSizeHeight);
      editSizeWidth.Text := IntToStr(FormSizeWidth);
      cbLogging.Checked := LogToFile;
      editLogName.Text := LogFileName;
      cbOpenAction.ItemIndex := Integer(LogMode);
      editSeperator.Text := SeperatorString;
      spinnerRepeat.Value := SeperatorRepeat;
      cbDateStamp.Checked := StampDate;
      cbTimeStamp.Checked := StampTime;
    end;
  updatingDemo := False;
end;

function TfrmDemo.FontDesc(infoFont: TFont): String;
var
  tmp: String;
begin
  with infoFont do
    begin
      tmp := '';
      if fsBold in Style then tmp := ' Bold';
      if fsItalic in Style then tmp := tmp + ' Italic';
      result := Format('%s (%d point%s)',[Name, Size, tmp]);
    end;
end;

procedure TfrmDemo.mnFExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfrmDemo.btnDoObjectClick(Sender: TObject);
begin
  with cboxDebugList do
    begin
      if (ItemIndex = -1) and (Text <> '') then
          ItemIndex := Items.AddObject(Text, TSSDebugTracer.Create(self));

      if ItemIndex <> -1 then
        begin
          curDebug := TSSDebugTracer(Items.Objects[ItemIndex]);
          UpdateDemo;
        end;
    end;
end;

procedure TfrmDemo.cboxDebugListKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9','A'..'Z','a'..'z', #8]) then Key := #0;
end;

procedure TfrmDemo.cbWinVisibleClick(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
      curDebug.DebugVisible := cbWinVisible.Checked;
end;

procedure TfrmDemo.cbToolVisibleClick(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
      curDebug.ToolBarVisible := cbToolVisible.Checked;
end;

procedure TfrmDemo.cbStayOnTopClick(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
      curDebug.StayOnTop := cbStayOnTop.Checked;
end;

procedure TfrmDemo.btnClearClick(Sender: TObject);
begin
  if Assigned(curDebug) then curDebug.Clear;
end;

procedure TfrmDemo.btnDisplayClick(Sender: TObject);
begin
  if Assigned(curDebug) then curDebug.Display(editDisplay.Text);
end;

procedure TfrmDemo.btnDisplayFmtClick(Sender: TObject);
begin
  if Assigned(curDebug) then curDebug.DisplayFmt('Testing DisplayFmt: %d, %s %p',[123, 'the quick...', nil]);
end;

procedure TfrmDemo.btnSeperatorClick(Sender: TObject);
begin
  if Assigned(curDebug) then curDebug.DisplaySeperator;
end;

procedure TfrmDemo.btnStringsClick(Sender: TObject);
begin
  if Assigned(curDebug) then curDebug.DisplayStrings(Memo1.Lines);
end;

procedure TfrmDemo.btnVarsClick(Sender: TObject);
begin
  if Assigned(curDebug) then curDebug.DisplayVars([123, 123.321, 'test string', nil]);
end;

procedure TfrmDemo.btnPrintClick(Sender: TObject);
begin
  if Assigned(curDebug) then curDebug.Print;
end;

procedure TfrmDemo.btnSaveClick(Sender: TObject);
begin
  if Assigned(curDebug) then curDebug.Save;
end;

procedure TfrmDemo.btnWinFontClick(Sender: TObject);
begin
  if Assigned(curDebug) then
    with FontDialog do
      begin
        Font := curDebug.TextFont;
        if Execute then
          begin
            curDebug.TextFont := Font;
            UpdateDemo;
          end;
      end;
end;

procedure TfrmDemo.editHeaderChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
      curDebug.HeaderText := editHeader.Text;
end;

procedure TfrmDemo.Button1Click(Sender: TObject);
begin
  if Assigned(curDebug) then
    with FontDialog do
      begin
        Font := curDebug.HeaderFont;
        if Execute then
          begin
            curDebug.HeaderFont := Font;
            UpdateDemo;
          end;
      end;
end;

procedure TfrmDemo.Button2Click(Sender: TObject);
begin
  if Assigned(curDebug) then
    with FontDialog do
      begin
        Font := curDebug.SubHeaderFont;
        if Execute then
          begin
            curDebug.SubHeaderFont := Font;
            UpdateDemo;
          end;
      end;
end;

procedure TfrmDemo.cbLocHorzChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
    begin
      curDebug.FormLocationH := TSSFormLocHorz(cbLocHorz.ItemIndex);
      UpdateDemo;
    end;
end;

procedure TfrmDemo.cbLocVertChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
    begin
      curDebug.FormLocationV := TSSFormLocVert(cbLocVert.ItemIndex);
      UpdateDemo;
    end;
end;

procedure TfrmDemo.editTopKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', #8]) then Key := #0;
end;

procedure TfrmDemo.editTopChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
    begin
      curDebug.FormLocationTop := StrToIntDef(editTop.Text,0);
      UpdateDemo;
    end;
end;

procedure TfrmDemo.editLeftChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
    begin
      curDebug.FormLocationLeft := StrToIntDef(editLeft.Text,0);
      UpdateDemo;
    end;
end;

procedure TfrmDemo.cbSizeHeightChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
    begin
      curDebug.FormSizeH := TSSFormSize(cbSizeHeight.ItemIndex);
      UpdateDemo;
    end;
end;

procedure TfrmDemo.cbSizeWidthChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
    begin
      curDebug.FormSizeW := TSSFormSize(cbSizeWidth.ItemIndex);
      UpdateDemo;
    end;
end;

procedure TfrmDemo.editSizeHeightChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
    begin
      curDebug.FormSizeHeight := StrToIntDef(editSizeHeight.Text,0);
      UpdateDemo;
    end;
end;

procedure TfrmDemo.editSizeWidthChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
    begin
      curDebug.FormSizeWidth := StrToIntDef(editSizeWidth.Text,0);
      UpdateDemo;
    end;
end;

procedure TfrmDemo.cbLoggingClick(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
      curDebug.LogToFile := cbLogging.Checked;
end;

procedure TfrmDemo.cbOpenActionChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
    begin
      curDebug.LogMode := TSSLogMode(cbOpenAction.ItemIndex);
      UpdateDemo;
    end;
end;

procedure TfrmDemo.editLogNameChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
      curDebug.LogFileName := editLogName.Text;
end;

procedure TfrmDemo.editSeperatorChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
      curDebug.SeperatorString := editSeperator.Text;
end;

procedure TfrmDemo.spinnerRepeatChange(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
      curDebug.SeperatorRepeat := spinnerRepeat.Value;
end;

procedure TfrmDemo.cbDateStampClick(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
      curDebug.StampDate := cbDateStamp.Checked;
end;

procedure TfrmDemo.cbTimeStampClick(Sender: TObject);
begin
  if (not updatingDemo) and Assigned(curDebug) then
      curDebug.StampTime := cbTimeStamp.Checked;
end;

procedure TfrmDemo.FormCreate(Sender: TObject);
begin
  label1.Hint := Label22.Hint;
  label10.Hint := Label23.Hint;
  label11.Hint := Label24.Hint;
  label16.Hint := Label25.Hint;
  label17.Hint := Label26.Hint;
  label18.Hint := Label27.Hint;
  label19.Hint := Label28.Hint;
  label20.Hint := Label29.Hint;
  label21.Hint := Label30.Hint;
end;

procedure TfrmDemo.Hints1Click(Sender: TObject);
begin
  Hints1.Checked := not Hints1.Checked;
  frmDemo.ShowHint := Hints1.Checked;
end;

procedure TfrmDemo.mnHAboutClick(Sender: TObject);
begin
  with TAboutBox.Create(nil) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TfrmDemo.WMGetMinMaxInfo(var Message: TMessage);
begin
  with PMinMaxInfo(Message.lParam)^ do
    begin
      ptMaxTrackSize.X := 640;
      ptMaxTrackSize.Y := 448;
      ptMinTrackSize.X := 640;
      ptMinTrackSize.Y := 448;
    end;
end;

end.
